//
// Created by zx on 2020/8/26.
//
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/io/zero_copy_stream_impl.h>
#include <google/protobuf/text_format.h>
#include "process_task.h"
#include "pathcreator.h"
#include "command_accepter.h"

thread_safe_map<std::string,int>   Process_task::m_storing_carlicense_terminal_id;
thread_safe_map<std::string,int>   Process_task::m_picking_carlicense_terminal_id;

Process_task::Process_task(message::Id_struct id,message::Car_info car_info)
        :m_publish_statu_thread(nullptr)
{
    m_id=id;
    m_car_info=car_info;
    m_step_index=0;
}
Process_task::~Process_task()
{

}

Error_manager Process_task::init_task(const ::google::protobuf::Message& parameter)
{
    ///创建状态发布线程
    if(m_publish_statu_thread== nullptr)
    {
        m_publish_exit_condition.reset(false, false, false);
        m_publish_statu_thread=new std::thread(publish_thread_func,this);
    }
    return SUCCESS;
}


/*
 * 取消任务
 */
void Process_task::Cancel()
{
    m_current_step_type= message::eBackComplete;
    m_cancel_condition.set_pass_ever(true);
    ALOG(WARNING)<<"取消当前任务";
    tq::BaseTask::Cancel();
}

/*
 * 发布进度
 */
void Process_task::publish_thread_func(Process_task* ptask)
{
    if(ptask)
    {
        //未收到退出信号
        while(false==ptask->m_publish_exit_condition.wait_for_ex(std::chrono::milliseconds(100))) {
            ptask->publish_step_status();
        }
    }
}

/*
     * 任务是否取消
     */
bool Process_task::is_canceled()
{
    return m_cancel_condition.wait_for_millisecond(1);
}

#include<fcntl.h>

//普通日志
void Process_task::add_log(int severity,std::string log)
{
    /*message::Log_data log_data;
    log_data.set_log_severity(message::Log_data_Severity (severity));
    log_data.set_str_log(log);
    m_process_log.mutable_log_data()->Add(std::move(log_data));*/
}
//以下是节点日志
void Process_task::add_log(int severity,const message::Node_log& data)
{
    /*message::Log_data log_data;
    log_data.set_log_severity(message::Log_data_Severity(severity));
    log_data.mutable_node_log()->CopyFrom(data);
    m_process_log.mutable_log_data()->Add(std::move(log_data));*/
}
void Process_task::add_log(int severity,const message::Manual_operation_log& data)
{
    /*message::Log_data log_data;
    log_data.set_log_severity(message::Log_data_Severity(severity));
    log_data.mutable_manual_operator_log()->CopyFrom(data);
    m_process_log.mutable_log_data()->Add(std::move(log_data));*/
}

void Process_task::Main()
{
    //保存日志记录
    time_t tt;
    time( &tt );
    tt = tt + 8*3600;  // transform the time zone
    tm* t= gmtime( &tt );

    char buf[255]={0};
    getcwd(buf,255);
    char strdir[255]={0};
    sprintf(strdir,"%s/process_log/%d/%02d/%02d",
            buf,t->tm_year + 1900,
            t->tm_mon + 1,
            t->tm_mday);
    PathCreator creator;
    creator.Mkdir(strdir);

    char filename[255]={0};
    std::string type=m_process_log.process_type()==message::eStoring?"停":"取";
    sprintf(filename,"%02d%02d%02d-%s-%s.proto",
            t->tm_hour,
            t->tm_min,
            t->tm_sec,
            m_car_info.license().c_str(),
            type.c_str());

    char logPath[255] = { 0 };
    sprintf(logPath, "%s/%s", strdir,filename);
    to_proto(logPath);
    /*for(int i=0;i<m_process_log.log_data_size();++i)
    {
        message::Log_data data=m_process_log.log_data(i);
        if(data.data_case()==message::Log_data::kStrLog)
        {
            std::cout<<" strlog:"<<data.str_log()<<std::endl;
        }
    }*/
}

void Process_task::to_proto(std::string proto_file)
{
    /*using google::protobuf::io::FileInputStream;
    using google::protobuf::io::FileOutputStream;
    using google::protobuf::io::ZeroCopyInputStream;
    using google::protobuf::io::CodedInputStream;
    using google::protobuf::io::ZeroCopyOutputStream;
    using google::protobuf::io::CodedOutputStream;
    using google::protobuf::Message;


    int fd = open(proto_file.c_str(), O_WRONLY | O_CREAT | O_TRUNC, 0644);
    FileOutputStream* output = new FileOutputStream(fd);
    CHECK(google::protobuf::TextFormat::Print(m_process_log, output));
    delete output;
    close(fd);*/

    int file=open(proto_file.c_str(),O_CREAT|O_TRUNC|O_RDWR,0644);
    if(-1!=file)
    {
        if(m_process_log.SerializeToFileDescriptor(file))
            return ;
    }
    LOG(WARNING)<<" process log ToProto failed :"<<proto_file;

}